//  Beispiel 6.5.3 "A/D Wandler ESP32"
//  
//  In diesem Beispiel werden die an den internen ADCs gemessenen Spannungen auf dem OLED angezeigt.
//
//  Unter Verwendung der IoT32 Brick Library

#include <all_IoT32.h>

void setup(void)
{
  IoT_Init(true);
}

void loop(void)
{
  int analogIN0 = IoT_AnalogRead(IoT_Analog0);                      // Liest Spannung als Rohwert: 0 = 0V bis 1023 = 3,3 V
  int analogIN1 = IoT_AnalogRead(IoT_Analog1);                      // Liest Spannung als Rohwert: 0 = 0V bis 1023 = 3,3 V
  int analogIN2 = IoT_AnalogRead(IoT_Analog2);                      // Liest Spannung als Rohwert: 0 = 0V bis 1023 = 3,3 V
  int analogIN3 = IoT_AnalogRead(IoT_Analog3);                      // Liest Spannung als Rohwert: 0 = 0V bis 1023 = 3,3 V
  
  double UMess0 = (double)analogIN0 / 4096.0 * 3.3;                 // Umrechnen in Volt
  String UMess_str0 = strrealform(UMess0, 32, 1, 2, false, false);  // In String umwandeln für OLED mit 2 Nachkommastellen
  double UMess1 = (double)analogIN1 / 4096.0 * 3.3;                 // Umrechnen in Volt
  String UMess_str1 = strrealform(UMess1, 32, 1, 2, false, false);  // In String umwandeln für OLED mit 2 Nachkommastellen
  double UMess2 = (double)analogIN2 / 4096.0 * 3.3;                 // Umrechnen in Volt
  String UMess_str2 = strrealform(UMess2, 32, 1, 2, false, false);  // In String umwandeln für OLED mit 2 Nachkommastellen
  double UMess3 = (double)analogIN3 / 4096.0 * 3.3;                 // Umrechnen in Volt
  String UMess_str3 = strrealform(UMess3, 32, 1, 2, false, false);  // In String umwandeln für OLED mit 2 Nachkommastellen

  Serial.print("A0 = ");
  Serial.print(UMess0);
  Serial.print(" V (");
  Serial.print(analogIN0);
  Serial.print(")  ");
  Serial.print("A1 = ");
  Serial.print(UMess1);
  Serial.print(" V (");
  Serial.print(analogIN1);
  Serial.print(")  ");
  Serial.print("A2 = ");
  Serial.print(UMess2);
  Serial.print(" V (");
  Serial.print(analogIN2);
  Serial.print(")  ");
  Serial.print("A3 = ");
  Serial.print(UMess3);
  Serial.print(" V (");
  Serial.print(analogIN3);
  Serial.println(")");

  IoT_DisplayClear(16);                                           // OLED Display löschen (24 Punkt Schrift)
  IoT_DisplayAlignText(TEXT_ALIGN_LEFT);
  IoT_DisplayDrawText(0, 0, "ADC 1.0:");
  IoT_DisplayAlignText(TEXT_ALIGN_RIGHT);
  IoT_DisplayDrawText(120, 0, UMess_str0 + " V");
  IoT_DisplayAlignText(TEXT_ALIGN_LEFT);
  IoT_DisplayDrawText(0, 16, "ADC 1.1:");
  IoT_DisplayAlignText(TEXT_ALIGN_RIGHT);
  IoT_DisplayDrawText(120, 16, UMess_str1 + " V");
  IoT_DisplayAlignText(TEXT_ALIGN_LEFT);
  IoT_DisplayDrawText(0, 32, "ADC 1.2:");
  IoT_DisplayAlignText(TEXT_ALIGN_RIGHT);
  IoT_DisplayDrawText(120, 32, UMess_str2 + " V");
  IoT_DisplayAlignText(TEXT_ALIGN_LEFT);
  IoT_DisplayDrawText(0, 48, "ADC 1.3:");
  IoT_DisplayAlignText(TEXT_ALIGN_RIGHT);
  IoT_DisplayDrawText(120, 48, UMess_str3 + " V");

  IoT_DisplayUpdate();                                            // OLED-Anzeige aktualisieren
  
  delay(1000);
}

